#include <cstdlib>
#include <iostream>
#include <memory>
#include <string>
#include <vector>

#include "constexp.h"
#include "ifswitch.h"
#include "initlist.h"
#include "null.h"
#include "version.h"

int main(int argc, char **argv) {

  std::cout << "Running " << PROJECT_NAME << ", version " << VERSION << "\n"
            << std::endl;

  std::vector<std::tuple<std::string, std::unique_ptr<ChapterTest>>>
      chapterTests;
  chapterTests.emplace_back("Null test", std::make_unique<NullTest>());
  chapterTests.emplace_back("If/Switch test", std::make_unique<IfswitchTest>());
  chapterTests.emplace_back("Constexpr test", std::make_unique<ConstExpTest>());
  chapterTests.emplace_back("Initializer list test",
                            std::make_unique<InitListTest>());

  for (auto &[name, test] : chapterTests) {
    std::cout << "\n" << name << std::endl;
    test->run();
  }

  std::cout << "\nExiting" << std::endl;

  return EXIT_SUCCESS;
}
